<?php

namespace XenGenTr\XenOneCikanKonular\Widget;

class Onecikanlar extends \XF\Widget\AbstractWidget
{
	protected $defaultOptions = [
		'limit' => 5,
		'trim' => 200,
	];
	
	public function render()
	{   
        /*** kullanc snrla ***/
		$visitor = \XF::visitor();				
        if (!$visitor->hasPermission('OneCikanKonular_izinler', 'onecikan_gor'))
        {
            return '';
        }
      
        /*** Gsterim limitle ***/
		$options = $this->options;
		$limit = $options['limit'];
        $limit = \XF::options()->XenGenTr_OneCikanKonular_gosterim_sayisi;

        /** @var \XenGenTr\XenOneCikanKonular\Repository */
		$onecikanRepo = $this->app->repository('XenGenTr\XenOneCikanKonular:Onecikan');

		$entries = $onecikanRepo->findOnecikan()->limit(max($limit * 2, 10))
			->where('Thread.discussion_state', 'visible');
		
		if (!$onecikanlar = $entries->fetch())
		{
			return false;
		}
		
		$onecikanlar = $onecikanlar->slice(0, $limit, true);

		$viewParams = [
			'onecikanlar' => $onecikanRepo->parseOnecikanlar($onecikanlar, $options['trim']),
		];
		
		return $this->renderer('XenGenTr_OneCikanKonular_widget', $viewParams);
	}

	public function verifyOptions(\XF\Http\Request $request, array &$options, &$error = null)
	{
		$options = $request->filter([
			'limit' => 'uint',
			'trim' => 'uint',
		]);

		if ($options['limit'] < 1)
		{
			$options['limit'] = 1;
		}
		
		return true;
	}
}